searchData={"items":[{"type":"module","title":"euneus","doc":"Core module. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus.html"},{"type":"function","title":"euneus.decode/1","doc":"Equivalent to euneus_decoder_smart:decode / 1. Parses JSON to Erlang term. See also: euneus_decoder_smart:decode/1 .","ref":"euneus.html#decode/1"},{"type":"function","title":"euneus.decode/2","doc":"Equivalent to euneus_decoder:decode / 2. Parses JSON to Erlang term. See also: euneus_decoder:decode/2 .","ref":"euneus.html#decode/2"},{"type":"function","title":"euneus.decode_parsed/2","doc":"Equivalent to euneus_decoder:decode_parsed / 2. Parses JSON to Erlang term. See also: euneus_decoder:decode_parsed/2 .","ref":"euneus.html#decode_parsed/2"},{"type":"function","title":"euneus.encode/1","doc":"Equivalent to euneus_encoder_smart_json:encode / 1. Generates a JSON from Erlang term. Uses JSON encoder. See also: euneus_encoder_smart_json:encode/1 .","ref":"euneus.html#encode/1"},{"type":"function","title":"euneus.encode/2","doc":"Equivalent to euneus_encoder:encode / 2. Generates a JSON from Erlang term. See also: euneus_encoder:encode/2 .","ref":"euneus.html#encode/2"},{"type":"function","title":"euneus.encode_html/1","doc":"Equivalent to euneus_encoder_smart_html:encode / 1. Generates a JSON from Erlang term. Uses HTML encoder. See also: euneus_encoder_smart_html:encode/1 .","ref":"euneus.html#encode_html/1"},{"type":"function","title":"euneus.encode_html_to_binary/1","doc":"Generates a JSON as erlang:binary() from Erlang term. Uses HTML encoder. See also: euneus_encoder_smart_html:encode/1 .","ref":"euneus.html#encode_html_to_binary/1"},{"type":"function","title":"euneus.encode_js/1","doc":"Equivalent to euneus_encoder_smart_javascript:encode / 1. Generates a JSON from Erlang term. Uses Javascript encoder. See also: euneus_encoder_smart_javascript:encode/1 .","ref":"euneus.html#encode_js/1"},{"type":"function","title":"euneus.encode_js_to_binary/1","doc":"Generates a JSON as erlang:binary() from Erlang term. Uses Javascript encoder. See also: euneus_encoder_smart_javascript:encode/1 .","ref":"euneus.html#encode_js_to_binary/1"},{"type":"function","title":"euneus.encode_parsed/2","doc":"Equivalent to euneus_encoder:encode_parsed / 2. Generates a JSON from Erlang term. See also: euneus_encoder:encode_parsed/2 .","ref":"euneus.html#encode_parsed/2"},{"type":"function","title":"euneus.encode_parsed_to_binary/2","doc":"Generates a JSON as erlang:binary() from Erlang term. See also: euneus_encoder:encode_parsed/2 .","ref":"euneus.html#encode_parsed_to_binary/2"},{"type":"function","title":"euneus.encode_to_binary/1","doc":"Generates a JSON as erlang:binary() from Erlang term. Uses JSON encoder. See also: euneus_encoder_smart_json:encode/1 .","ref":"euneus.html#encode_to_binary/1"},{"type":"function","title":"euneus.encode_to_binary/2","doc":"Generates a JSON as erlang:binary() from Erlang term. See also: euneus_encoder:encode/2 .","ref":"euneus.html#encode_to_binary/2"},{"type":"function","title":"euneus.encode_unicode/1","doc":"Equivalent to euneus_encoder_smart_unicode:encode / 1. Generates a JSON from Erlang term. Uses Unicode encoder. See also: euneus_encoder_smart_unicode:encode/1 .","ref":"euneus.html#encode_unicode/1"},{"type":"function","title":"euneus.encode_unicode_to_binary/1","doc":"Generates a JSON as erlang:binary() from Erlang term. Uses Unicode encoder. See also: euneus_encoder_smart_unicode:encode/1 .","ref":"euneus.html#encode_unicode_to_binary/1"},{"type":"function","title":"euneus.parse_decode_opts/1","doc":"Equivalent to euneus_decoder:parse_opts / 1. Parses erlang:map() to euneus_decoder:options() . See also: euneus_decoder:decode_parsed/2 , euneus_decoder:parse_opts/1 .","ref":"euneus.html#parse_decode_opts/1"},{"type":"function","title":"euneus.parse_encode_opts/1","doc":"Equivalent to euneus_encoder:parse_opts / 1. Parses erlang:map() to euneus_encoder:options() . See also: euneus_encoder:encode_parsed/2 , euneus_encoder:parse_opts/1 .","ref":"euneus.html#parse_encode_opts/1"},{"type":"type","title":"euneus.decode_input/0","doc":null,"ref":"euneus.html#t:decode_input/0"},{"type":"type","title":"euneus.decode_opts/0","doc":null,"ref":"euneus.html#t:decode_opts/0"},{"type":"type","title":"euneus.decode_result/0","doc":null,"ref":"euneus.html#t:decode_result/0"},{"type":"type","title":"euneus.encode_input/0","doc":null,"ref":"euneus.html#t:encode_input/0"},{"type":"type","title":"euneus.encode_opts/0","doc":null,"ref":"euneus.html#t:encode_opts/0"},{"type":"type","title":"euneus.encode_result/0","doc":null,"ref":"euneus.html#t:encode_result/0"},{"type":"type","title":"euneus.encode_to_bin_result/0","doc":null,"ref":"euneus.html#t:encode_to_bin_result/0"},{"type":"module","title":"euneus_decoder","doc":"JSON parser. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_decoder.html"},{"type":"function","title":"euneus_decoder.decode/2","doc":"Parses JSON to Erlang term.","ref":"euneus_decoder.html#decode/2"},{"type":"function","title":"euneus_decoder.decode_parsed/2","doc":"Parses JSON to Erlang term.","ref":"euneus_decoder.html#decode_parsed/2"},{"type":"function","title":"euneus_decoder.get_arrays_option/1","doc":null,"ref":"euneus_decoder.html#get_arrays_option/1"},{"type":"function","title":"euneus_decoder.get_error_handler_option/1","doc":null,"ref":"euneus_decoder.html#get_error_handler_option/1"},{"type":"function","title":"euneus_decoder.get_keys_option/1","doc":null,"ref":"euneus_decoder.html#get_keys_option/1"},{"type":"function","title":"euneus_decoder.get_null_term_option/1","doc":null,"ref":"euneus_decoder.html#get_null_term_option/1"},{"type":"function","title":"euneus_decoder.get_objects_option/1","doc":null,"ref":"euneus_decoder.html#get_objects_option/1"},{"type":"function","title":"euneus_decoder.get_plugins_option/1","doc":null,"ref":"euneus_decoder.html#get_plugins_option/1"},{"type":"function","title":"euneus_decoder.get_values_option/1","doc":null,"ref":"euneus_decoder.html#get_values_option/1"},{"type":"function","title":"euneus_decoder.handle_error/3","doc":"Handles decoding errors.","ref":"euneus_decoder.html#handle_error/3"},{"type":"function","title":"euneus_decoder.parse_opts/1","doc":"Parses erlang:map() to euneus_encoder:options() . The parsed map can be expanded in compile time or stored to be reused, avoiding parsing the options in every encoding. See also: euneus_encoder:encode_parsed/2 , euneus_encoder:parse_opts/1 .","ref":"euneus_decoder.html#parse_opts/1"},{"type":"function","title":"euneus_decoder.resume/6","doc":"Resumes the decoding after a token error. Passes the null_term option as the Replacement argument of euneus_decoder:resume/7 .","ref":"euneus_decoder.html#resume/6"},{"type":"function","title":"euneus_decoder.resume/7","doc":"Resumes the decoding after a token error.","ref":"euneus_decoder.html#resume/7"},{"type":"type","title":"euneus_decoder.error_class/0","doc":null,"ref":"euneus_decoder.html#t:error_class/0"},{"type":"type","title":"euneus_decoder.error_handler/0","doc":null,"ref":"euneus_decoder.html#t:error_handler/0"},{"type":"type","title":"euneus_decoder.error_reason/0","doc":null,"ref":"euneus_decoder.html#t:error_reason/0"},{"type":"type","title":"euneus_decoder.error_stacktrace/0","doc":null,"ref":"euneus_decoder.html#t:error_stacktrace/0"},{"type":"type","title":"euneus_decoder.input/0","doc":null,"ref":"euneus_decoder.html#t:input/0"},{"type":"type","title":"euneus_decoder.invalid_option_error/0","doc":null,"ref":"euneus_decoder.html#t:invalid_option_error/0"},{"type":"type","title":"euneus_decoder.normalizer/1","doc":null,"ref":"euneus_decoder.html#t:normalizer/1"},{"type":"opaque","title":"euneus_decoder.options/0","doc":null,"ref":"euneus_decoder.html#t:options/0"},{"type":"type","title":"euneus_decoder.position/0","doc":null,"ref":"euneus_decoder.html#t:position/0"},{"type":"type","title":"euneus_decoder.result/0","doc":null,"ref":"euneus_decoder.html#t:result/0"},{"type":"type","title":"euneus_decoder.unexpected_byte_error/0","doc":null,"ref":"euneus_decoder.html#t:unexpected_byte_error/0"},{"type":"type","title":"euneus_decoder.unexpected_end_of_input_error/0","doc":null,"ref":"euneus_decoder.html#t:unexpected_end_of_input_error/0"},{"type":"type","title":"euneus_decoder.unexpected_sequence_error/0","doc":null,"ref":"euneus_decoder.html#t:unexpected_sequence_error/0"},{"type":"module","title":"euneus_decoder_smart","doc":"JSON parser without any options for better performance. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_decoder_smart.html"},{"type":"function","title":"euneus_decoder_smart.decode/1","doc":null,"ref":"euneus_decoder_smart.html#decode/1"},{"type":"type","title":"euneus_decoder_smart.input/0","doc":null,"ref":"euneus_decoder_smart.html#t:input/0"},{"type":"type","title":"euneus_decoder_smart.result/0","doc":null,"ref":"euneus_decoder_smart.html#t:result/0"},{"type":"module","title":"euneus_encoder","doc":"JSON generator. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_encoder.html"},{"type":"function","title":"euneus_encoder.encode/2","doc":"Generates a JSON from Erlang term.","ref":"euneus_encoder.html#encode/2"},{"type":"function","title":"euneus_encoder.encode_atom/2","doc":null,"ref":"euneus_encoder.html#encode_atom/2"},{"type":"function","title":"euneus_encoder.encode_binary/2","doc":null,"ref":"euneus_encoder.html#encode_binary/2"},{"type":"function","title":"euneus_encoder.encode_float/2","doc":null,"ref":"euneus_encoder.html#encode_float/2"},{"type":"function","title":"euneus_encoder.encode_integer/2","doc":null,"ref":"euneus_encoder.html#encode_integer/2"},{"type":"function","title":"euneus_encoder.encode_list/2","doc":null,"ref":"euneus_encoder.html#encode_list/2"},{"type":"function","title":"euneus_encoder.encode_map/2","doc":null,"ref":"euneus_encoder.html#encode_map/2"},{"type":"function","title":"euneus_encoder.encode_parsed/2","doc":"Generates a JSON from Erlang term. See also: euneus_encoder:parse_opts/1 .","ref":"euneus_encoder.html#encode_parsed/2"},{"type":"function","title":"euneus_encoder.encode_unhandled/2","doc":null,"ref":"euneus_encoder.html#encode_unhandled/2"},{"type":"function","title":"euneus_encoder.escape/2","doc":null,"ref":"euneus_encoder.html#escape/2"},{"type":"function","title":"euneus_encoder.escape_byte/1","doc":null,"ref":"euneus_encoder.html#escape_byte/1"},{"type":"function","title":"euneus_encoder.escape_html/1","doc":null,"ref":"euneus_encoder.html#escape_html/1"},{"type":"function","title":"euneus_encoder.escape_js/1","doc":null,"ref":"euneus_encoder.html#escape_js/1"},{"type":"function","title":"euneus_encoder.escape_json/1","doc":null,"ref":"euneus_encoder.html#escape_json/1"},{"type":"function","title":"euneus_encoder.escape_unicode/1","doc":null,"ref":"euneus_encoder.html#escape_unicode/1"},{"type":"function","title":"euneus_encoder.get_atom_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_atom_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_binary_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_binary_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_error_handler_option/1","doc":null,"ref":"euneus_encoder.html#get_error_handler_option/1"},{"type":"function","title":"euneus_encoder.get_escaper_option/1","doc":null,"ref":"euneus_encoder.html#get_escaper_option/1"},{"type":"function","title":"euneus_encoder.get_float_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_float_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_integer_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_integer_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_list_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_list_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_map_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_map_encoder_option/1"},{"type":"function","title":"euneus_encoder.get_nulls_option/1","doc":null,"ref":"euneus_encoder.html#get_nulls_option/1"},{"type":"function","title":"euneus_encoder.get_plugins_option/1","doc":null,"ref":"euneus_encoder.html#get_plugins_option/1"},{"type":"function","title":"euneus_encoder.get_unhandled_encoder_option/1","doc":null,"ref":"euneus_encoder.html#get_unhandled_encoder_option/1"},{"type":"function","title":"euneus_encoder.handle_error/3","doc":null,"ref":"euneus_encoder.html#handle_error/3"},{"type":"function","title":"euneus_encoder.parse_opts/1","doc":"Parses erlang:map() to euneus_encoder:options() . The parsed map can be expanded in compile time or stored to be reused, avoiding parsing the options in every encoding. See also: euneus_encoder:encode_parsed/2 , euneus_encoder:parse_opts/1 .","ref":"euneus_encoder.html#parse_opts/1"},{"type":"function","title":"euneus_encoder.throw_unsupported_type_error/1","doc":null,"ref":"euneus_encoder.html#throw_unsupported_type_error/1"},{"type":"type","title":"euneus_encoder.encoder/1","doc":null,"ref":"euneus_encoder.html#t:encoder/1"},{"type":"type","title":"euneus_encoder.error_class/0","doc":null,"ref":"euneus_encoder.html#t:error_class/0"},{"type":"type","title":"euneus_encoder.error_handler/0","doc":null,"ref":"euneus_encoder.html#t:error_handler/0"},{"type":"type","title":"euneus_encoder.error_reason/0","doc":null,"ref":"euneus_encoder.html#t:error_reason/0"},{"type":"type","title":"euneus_encoder.error_stacktrace/0","doc":null,"ref":"euneus_encoder.html#t:error_stacktrace/0"},{"type":"type","title":"euneus_encoder.escaper/1","doc":null,"ref":"euneus_encoder.html#t:escaper/1"},{"type":"type","title":"euneus_encoder.input/0","doc":null,"ref":"euneus_encoder.html#t:input/0"},{"type":"type","title":"euneus_encoder.invalid_byte_error/0","doc":null,"ref":"euneus_encoder.html#t:invalid_byte_error/0"},{"type":"opaque","title":"euneus_encoder.options/0","doc":null,"ref":"euneus_encoder.html#t:options/0"},{"type":"type","title":"euneus_encoder.result/0","doc":null,"ref":"euneus_encoder.html#t:result/0"},{"type":"type","title":"euneus_encoder.unsupported_type_error/0","doc":null,"ref":"euneus_encoder.html#t:unsupported_type_error/0"},{"type":"module","title":"euneus_encoder_smart_html","doc":"JSON parser without any options for better performance. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_encoder_smart_html.html"},{"type":"function","title":"euneus_encoder_smart_html.encode/1","doc":null,"ref":"euneus_encoder_smart_html.html#encode/1"},{"type":"type","title":"euneus_encoder_smart_html.input/0","doc":null,"ref":"euneus_encoder_smart_html.html#t:input/0"},{"type":"type","title":"euneus_encoder_smart_html.result/0","doc":null,"ref":"euneus_encoder_smart_html.html#t:result/0"},{"type":"module","title":"euneus_encoder_smart_javascript","doc":"JSON parser without any options for better performance. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_encoder_smart_javascript.html"},{"type":"function","title":"euneus_encoder_smart_javascript.encode/1","doc":null,"ref":"euneus_encoder_smart_javascript.html#encode/1"},{"type":"type","title":"euneus_encoder_smart_javascript.input/0","doc":null,"ref":"euneus_encoder_smart_javascript.html#t:input/0"},{"type":"type","title":"euneus_encoder_smart_javascript.result/0","doc":null,"ref":"euneus_encoder_smart_javascript.html#t:result/0"},{"type":"module","title":"euneus_encoder_smart_json","doc":"JSON parser without any options for better performance. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_encoder_smart_json.html"},{"type":"function","title":"euneus_encoder_smart_json.encode/1","doc":null,"ref":"euneus_encoder_smart_json.html#encode/1"},{"type":"type","title":"euneus_encoder_smart_json.input/0","doc":null,"ref":"euneus_encoder_smart_json.html#t:input/0"},{"type":"type","title":"euneus_encoder_smart_json.result/0","doc":null,"ref":"euneus_encoder_smart_json.html#t:result/0"},{"type":"module","title":"euneus_encoder_smart_unicode","doc":"JSON parser without any options for better performance. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_encoder_smart_unicode.html"},{"type":"function","title":"euneus_encoder_smart_unicode.encode/1","doc":null,"ref":"euneus_encoder_smart_unicode.html#encode/1"},{"type":"type","title":"euneus_encoder_smart_unicode.input/0","doc":null,"ref":"euneus_encoder_smart_unicode.html#t:input/0"},{"type":"type","title":"euneus_encoder_smart_unicode.result/0","doc":null,"ref":"euneus_encoder_smart_unicode.html#t:result/0"},{"type":"behaviour","title":"euneus_plugin","doc":"Plugin behavior. Copyright 2023 William Fank Thomé Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"euneus_plugin.html"},{"type":"callback","title":"euneus_plugin.decode/2","doc":null,"ref":"euneus_plugin.html#c:decode/2"},{"type":"callback","title":"euneus_plugin.encode/2","doc":null,"ref":"euneus_plugin.html#c:encode/2"},{"type":"extras","title":"Overview","doc":"# Euneus\n\nAn incredibly flexible and performant JSON parser and generator.\n\nEuneus is a rewrite of [Thoas][thoas].\n\nLike Thoas, both the parser and generator fully conform to\n[RFC 8259](https://tools.ietf.org/html/rfc8259) and\n[ECMA 404](http://www.ecma-international.org/publications/standards/Ecma-404.htm).","ref":"readme.html"},{"type":"extras","title":"Table of Contents - Overview","doc":"- [Installation](#installation)\n    - [Erlang](#erlang)\n    - [Elixir](#elixir)\n- [Basic Usage](#basic-usage)\n- [Data Mapping](#data-mapping)\n    - [Why not more built-in types?](#why-not-more-built-in-types)\n    - [Note about proplists](#note-about-proplists)\n- [Plugins](#plugins)\n    - [Usage](#usage)\n        - [Encode](#encode)\n        - [Decode](#decode)\n    - [Built-in Plugins](#built-in-plugins)\n        - [datetime](#datetime)\n        - [inet](#inet)\n        - [pid](#pid)\n        - [port](#port)\n        - [proplist](#proplist)\n        - [reference](#reference)\n        - [timestamp](#timestamp)\n- [Differences to Thoas](#differences-to-thoas)\n    - [Encode](#encode-1)\n    - [Decode](#decode-1)\n        - [Resuming](#resuming)\n    - [Why Euneus over Thoas?](#why-euneus-over-thoas)\n- [Benchmarks](#benchmarks)\n    - [Encode](#encode-2)\n        - [Smart encoding](#smart-encoding)\n        - [Encoding with empty map as option](#encoding-with-empty-map-as-option)\n        - [Encoding with all built-in plugins](#encoding-with-all-built-in-plugins)\n    - [Decode](#decode-2)\n        - [Smart decoding](#smart-decoding)\n        - [Decoding with empty map as option](#decoding-with-empty-map-as-option)\n        - [Decoding with all built-in plugins](#decoding-with-all-built-in-plugins)\n- [Tests](#tests)\n- [Smart modules](#smart-modules)\n- [Credits](#credits)\n- [Why the name Euneus?](#why-the-name-euneus)\n- [Sponsors](#sponsors)\n- [Contributing](#contributing)\n    - [Issues](#issues)\n    - [Installation](#installation-1)\n    - [Commands](#commands)\n- [License](#license)","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Installation - Overview","doc":"#","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Overview","doc":"```erlang\n% rebar.config\n{deps, [{euneus, \"1.0.2\"}]}\n```\n\n#","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Overview","doc":"```elixir\n# mix.exs\ndef deps do\n  [{:euneus, \"~> 1.0\"}]\nend\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Basic Usage - Overview","doc":"```erlang\n1> {ok, JSON} = euneus:encode_to_binary(#{name => #{english =>  >, japanese =>  >}, type => [fire], profile => #{height => 0.6, weight => 8}, ability => #{0 =>  >, 1 => undefined}}).\n{ok,  >}\n\n2> euneus:decode(JSON).\n{ok,#{ > =>\n          #{ > =>  >, > => undefined},\n       > =>\n          #{ > =>  >,\n             > =>\n                 >},\n       > => #{ > => 0.6, > => 8},\n       > => [ >]}}\n\n3> euneus:decode(JSON, #{\n    keys => fun\n        ( > = Key, _Opts) when Char >= $0, Char = \n            binary_to_integer(Key);\n        (Key, _Opts) ->\n            binary_to_existing_atom(Key)\n    end\n}).\n{ok,#{name =>\n          #{english =>  >,\n            japanese =>\n                 >},\n      profile => #{height => 0.6,weight => 8},\n      type => [ >],\n      ability => #{0 =>  >,1 => undefined}}}\n```","ref":"readme.html#basic-usage"},{"type":"extras","title":"Data Mapping - Overview","doc":"> [!TIP]\n>\n> More types can be handled by using custom plugins. Please see the [Plugins](#plugins) section for more info.\n\n \n \n| **Erlang ->**                                                \t| **Encode Options ->**                                                                                                                    \t| **JSON ->**                          \t| **Decode Options ->**                                                                                           \t| **Erlang**                                                   \t|\n|--------------------------------------------------------------\t|------------------------------------------------------------------------------------------------------------------------------------------\t|--------------------------------------\t|-----------------------------------------------------------------------------------------------------------------\t|--------------------------------------------------------------\t|\n| undefined                                                    \t| #{}                                                                                                                                      \t| null                                 \t| #{}                                                                                                             \t| undefined                                                    \t|\n| undefined                                                    \t| #{}                                                                                                                                      \t| null                                 \t| #{null_term => nil}                                                                                             \t| nil                                                          \t|\n| true                                                         \t| #{}                                                                                                                                      \t| true                                 \t| #{}                                                                                                             \t| true                                                         \t|\n| false                                                        \t| #{}                                                                                                                                      \t| false                                \t| #{}                                                                                                             \t| false                                                        \t|\n| abc                                                          \t| #{}                                                                                                                                      \t| \"abc\"                                \t| #{}                                                                                                             \t|  >                                                    \t|\n| \"abc\"                                                        \t| #{}                                                                                                                                      \t| [97,98,99]                           \t| #{}                                                                                                             \t| \"abc\"                                                        \t|\n|  >                                                    \t| #{}                                                                                                                                      \t| \"abc\"                                \t| #{}                                                                                                             \t|  >                                                    \t|\n| 123                                                          \t| #{}                                                                                                                                      \t| 123                                  \t| #{}                                                                                                             \t| 123                                                          \t|\n| 123.45600                                                    \t| #{}                                                                                                                                      \t| 123.456                              \t| #{}                                                                                                             \t| 123.456                                                      \t|\n| [ >,true,0,undefined]                                 \t| #{}                                                                                                                                      \t| [\"foo\",true,0,null]                  \t| #{}                                                                                                             \t| [ >,true,0,undefined]                                 \t|\n| #{foo => bar}                                                \t| #{}                                                                                                                                      \t| {\"foo\":\"bar\"}                        \t| #{}                                                                                                             \t| #{ > =>  >}                                    \t|\n| #{foo => bar}                                                \t| #{}                                                                                                                                      \t| {\"foo\":\"bar\"}                        \t| #{keys => to_existing_atom}                                                                                     \t| #{foo =>  >}                                          \t|\n| #{0 => 0}                                                    \t| #{}                                                                                                                                      \t| {\"0\":0}                              \t| #{keys => to_integer}                                                                                           \t| #{0 => 0}                                                    \t|\n| {{1970,1,1},{0,0,0}}                                         \t| #{plugins => [datetime]}                                                                                                                 \t| \"1970-01-01T00:00:00Z\"               \t| #{plugins => [datetime]}                                                                                        \t| {{1970,1,1},{0,0,0}}                                         \t|\n| {127,0,0,1}                                                  \t| #{plugins => [inet]}                                                                                                                     \t| \"127.0.0.1\"                          \t| #{plugins => [inet]}                                                                                            \t| {127,0,0,1}                                                  \t|\n| {16#3ffe,16#b80,16#1f8d,16#2,16#204,16#acff,16#fe17,16#bf38} \t| #{plugins => [inet]}                                                                                                                     \t| \"3ffe:b80:1f8d:2:204:acff:fe17:bf38\" \t| #{plugins => [inet]}                                                                                            \t| {16#3ffe,16#b80,16#1f8d,16#2,16#204,16#acff,16#fe17,16#bf38} \t|\n|                                                       \t| #{plugins => [pid]}                                                                                                                      \t| \" \"                           \t| #{plugins => [pid]}                                                                                             \t|                                                       \t|\n| #Port                                                    \t| #{plugins => [port]}                                                                                                                     \t| \"#Port \"                         \t| #{plugins => [port]}                                                                                            \t| #Port                                                    \t|\n| [{foo, bar}]                                                 \t| #{plugins => [proplist]}                                                                                                                 \t| {\\\"foo\\\":\\\"bar\\\"}                    \t| #{plugins => [proplist]}                                                                                        \t| #{ > =>  >}                                    \t|\n| #Ref                            \t| #{plugins => [reference]}                                                                                                                \t| \"#Ref \" \t| #{plugins => [reference]}                                                                                       \t| #Ref                            \t|\n| {0,0,0}                                                      \t| #{plugins => [timestamp]}                                                                                                                \t| \"1970-01-01T00:00:00.000Z\"           \t| #{plugins => [timestamp]}                                                                                       \t| {0,0,0}                                                      \t|\n| {myrecord, val}                                              \t| #{unhandled_encoder => fun({myrecord, Val}, Opts) ->         euneus_encoder:encode_list([myrecord, #{key => Val}], Opts)  end}) \t| [\"myrecord\", {\"key\":\"val\"}]          \t| #{arrays => fun([ >, #{ > := Val}], _Opts) ->     {myrecord, binary_to_atom(Val)} end} \t| {myrecord, val}                                              \t|\n\n#","ref":"readme.html#data-mapping"},{"type":"extras","title":"Why not more built-in types? - Overview","doc":"The goal of `Euneus` is to have built-in types that can be commonly encoded and decoded, but the range of types can be easily extended by using plugins.  Please see the [Plugins](#plugins) section for more info.\n\n#","ref":"readme.html#why-not-more-built-in-types"},{"type":"extras","title":"Note about proplists - Overview","doc":"Proplists are not handled by Euneus by default.\n\nThere are three options:\n1. Use the built-in, or create your own, [proplist plugin](#proplist);\n2. Convert proplists to maps before the encoding;\n3. Override the `list_encoder` option in the encoder to handle them, for example:\n\n```erlang\n1> Options = #{\n       list_encoder => fun\n           ([{K, _} | _] = Proplist, Opts)\n             when is_binary(K); is_atom(K); is_integer(K) ->\n               Map = proplists:to_map(Proplist),\n               euneus_encoder:encode_map(Map, Opts);\n           (List, Opts) ->\n               euneus_encoder:encode_list(List, Opts)\n       end\n   }.\n\n2> Proplist = [{foo, bar}, {bar, [{0, ok}]}].\n\n3> euneus:encode_to_binary(Proplist, Options).\n{ok, >}\n```\n\nThe reason for that is because it's impossible to know when a list is a proplist and also because a proplist cannot be decoded. Please see the [Why not more built-in types?](#why-not-more-built-in-types) section for more info about this decision.","ref":"readme.html#note-about-proplists"},{"type":"extras","title":"Plugins - Overview","doc":"Euneus has a mechanism to easily plug in encoders and decoders. You can use the [built-in plugins](#built-in-plugins) to handle common types or create your own in a module by implementing the [euneus_plugin](/src/euneus_plugin.erl) behavior.\n\nIf you have a built-in plugin suggestion, feel free to open a [new issue](https://github.com/williamthome/euneus/issues/new) to discuss it.\n\n> [!IMPORTANT]\n> The plugins mechanism deprecated the `datetime_encoder` and the `timestamp_encoder` option in favor of the `datetime` and `timestamp` plugins.\n\n#","ref":"readme.html#plugins"},{"type":"extras","title":"Usage - Overview","doc":"##","ref":"readme.html#usage"},{"type":"extras","title":"Encode - Overview","doc":"```erlang\neuneus:encode(Term, #{plugins => [\n    % list of built-in or custom plugins\n]})\n```\n\n##","ref":"readme.html#encode"},{"type":"extras","title":"Decode - Overview","doc":"```erlang\neuneus:decode(Term, #{plugins => [\n    % list of built-in or custom plugins\n]})\n```\n\n#","ref":"readme.html#decode"},{"type":"extras","title":"Built-in Plugins - Overview","doc":"##","ref":"readme.html#built-in-plugins"},{"type":"extras","title":"datetime - Overview","doc":"Encodes `calendar:datetime()` to ISO8601 as JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary({{1970,1,1},{0,0,0}}, #{plugins => [datetime]}).\n{ok, >}\n\n2> euneus:decode(JSON, #{plugins => [datetime]}).\n{ok,{{1970,1,1},{0,0,0}}}\n```\n\n##","ref":"readme.html#datetime"},{"type":"extras","title":"inet - Overview","doc":"Encodes `inet:ip_address()` to IPV4 or IPV6 as JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary({127,0,0,1}, #{plugins => [inet]}).\n{ok, >}\n\n2> euneus:decode(JSON, #{plugins => [inet]}).\n{ok,{127,0,0,1}}\n```\n\n##","ref":"readme.html#inet"},{"type":"extras","title":"pid - Overview","doc":"Encodes `erlang:pid()` to JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary(list_to_pid(\" \"), #{plugins => [pid]}).\n{ok, \\\"\">>}\n\n2> euneus:decode(JSON, #{plugins => [pid]}).\n{ok, }\n```\n\n##","ref":"readme.html#pid"},{"type":"extras","title":"port - Overview","doc":"Encodes `erlang:port()` to JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary(list_to_port(\"#Port \"), #{plugins => [port]}).\n{ok, \\\"\">>}\n\n2> euneus:decode(JSON, #{plugins => [port]}).\n{ok,#Port }\n```\n\n##","ref":"readme.html#port"},{"type":"extras","title":"proplist - Overview","doc":"Encodes `[{binary() | atom() | integer(), term()}]` to JSON object, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary([{foo, bar}], #{plugins => [proplist]}).\n{ok, >}\n```\n\n##","ref":"readme.html#proplist"},{"type":"extras","title":"reference - Overview","doc":"Encodes `erlang:reference()` to JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary(make_ref(), #{plugins => [reference]}).\n{ok, \\\"\">>}\n\n2> euneus:decode(JSON, #{plugins => [reference]}).\n{ok,#Ref }\n```\n\n##","ref":"readme.html#reference"},{"type":"extras","title":"timestamp - Overview","doc":"Encodes `erlang:timestamp()` to ISO8601 as JSON string and decodes it back, for example:\n\n```erlang\n1> {ok, JSON} = euneus:encode_to_binary({0,0,0}, #{plugins => [timestamp]}).\n{ok, >}\n\n2> euneus:decode(JSON, #{plugins => [timestamp]}).\n{ok,{0,0,0}}\n```","ref":"readme.html#timestamp"},{"type":"extras","title":"Differences to Thoas - Overview","doc":"The main difference between `Euneus` to `Thoas` is that Euneus gives more control to encoding or decoding data. All encode functions can be overridden and extended and all decoded data can be overridden and transformed. Also, there is no plugin mechanism in Thoas.\n\n#","ref":"readme.html#differences-to-thoas"},{"type":"extras","title":"Encode - Overview","doc":"Available encode options:\n\n```erlang\n#{\n    %% nulls defines what terms will be replaced with the null literal (default: ['undefined']).\n    nulls => nonempty_list(),\n    %% binary_encoder allow override the binary() encoding.\n    binary_encoder => function((binary(), euneus_encoder:options()) -> iolist()),\n    %% atom_encoder allow override the atom() encoding.\n    atom_encoder => function((atom(), euneus_encoder:options()) -> iolist()),\n    %% integer_encoder allow override the integer() encoding.\n    integer_encoder => function((integer(), euneus_encoder:options()) -> iolist()),\n    %% float_encoder allow override the float() encoding.\n    float_encoder => function((float(), euneus_encoder:options()) -> iolist()),\n    %% list_encoder allow override the list() encoding.\n    list_encoder => function((list(), euneus_encoder:options()) -> iolist()),\n    %% map_encoder allow override the map() encoding.\n    map_encoder => function((map(), euneus_encoder:options()) -> iolist()),\n    %% unhandled_encoder allow encode any custom term (default: raise unsupported_type error).\n    unhandled_encoder => function((term(), euneus_encoder:options()) -> iolist()),\n    %% escaper allow override the binary escaping (default: json).\n    escaper => json\n             | html\n             | javascript\n             | unicode\n             | function((binary(), euneus_encoder:options()) -> iolist()),\n    error_handler => function(( error | exit | throw\n                              , term()\n                              , erlang:stacktrace() ) -> euneus_encoder:result()),\n    %% plugins extends the encode types.\n    plugins => datetime\n             | inet\n             | pid\n             | port\n             | proplist\n             | reference\n             | timestamp\n             | module() % that implements the `euneus_plugin` behavior.\n}\n```\n\nFor example:\n\n```erlang\n1> EncodeOpts = #{\n       binary_encoder => fun\n           ( >, Opts) ->\n               euneus_encoder:encode_binary( >, Opts);\n           (Bin, Opts) ->\n               euneus_encoder:encode_binary(Bin, Opts)\n       end,\n       unhandled_encoder => fun\n           ({_, _, _, _} = Ip, Opts) ->\n               case inet:ntoa(Ip) of\n                   {error, einval} ->\n                       throw(invalid_ip);\n                   IpStr ->\n                       IpBin = list_to_binary(IpStr),\n                       euneus_encoder:encode_binary(IpBin, Opts)\n               end;\n           (Term, Opts) ->\n               euneus_encoder:throw_unsupported_type_error(Term, Opts)\n       end,\n       error_handler => fun\n           (throw, invalid_ip, _Stacktrace) ->\n               {error, invalid_ip};\n           (Class, Reason, Stacktrace) ->\n               euneus_encoder:handle_error(Class, Reason, Stacktrace)\n       end\n   }.\n\n2> Data = #{ > => bar, ipv4 => {127,0,0,1}, none => undefined}.\n\n3> euneus:encode_to_binary(Data, EncodeOpts).\n{ok,  >}\n\n4> euneus:encode_to_binary({1270,0,0,1}, EncodeOpts).\n{error, invalid_ip}\n```\n\n#","ref":"readme.html#encode"},{"type":"extras","title":"Decode - Overview","doc":"Available decode options:\n\n```erlang\n#{\n    %% null_term is the null literal override (default: 'undefined').\n    null_term => term(),\n    %% arrays allow override any array/list().\n    arrays => function((list(), euneus_decoder:options()) -> term()),\n    %% objects allow override any object/map().\n    objects => function((map(), euneus_decoder:options()) -> term()),\n    %% keys allow override the keys from JSON objects.\n    keys => copy\n          | to_atom\n          | to_existing_atom\n          | to_integer\n          | function((binary(), euneus_decoder:options()) -> term()),\n    %% values allow override any other term, like array item or object value.\n    values => copy\n            | to_atom\n            | to_existing_atom\n            | to_integer\n            | function((binary(), euneus_decoder:options()) -> term()),\n    %% plugins extends the decode types.\n    plugins => datetime\n             | inet\n             | pid\n             | port\n             | reference\n             | timestamp\n             | module() % that implements the `euneus_plugin` behavior.\n}\n```\n\nFor example:\n\n```erlang\n1> DecodeOpts = #{\n      null_term => nil,\n      keys => fun\n          ( >, _Opts) ->\n              foo;\n          (Key, _Opts) ->\n              binary_to_atom(Key)\n      end,\n      values => fun\n          ( >, _Opts) ->\n              {127, 0, 0, 1};\n          (Value, _Opts) ->\n              Value\n      end\n   }.\n\n2> JSON =  >.\n\n3> euneus:decode(JSON, DecodeOpts).\n{ok,#{foo =>  >,\n      ipv4 => {127,0,0,1},\n      none => nil}}\n```\n\n##","ref":"readme.html#decode"},{"type":"extras","title":"Resuming - Overview","doc":"Euneus permits resuming the decoding when an invalid token is found. Any value can replace the invalid token by overriding the `error_handler` option, e.g.:\n\n```erlang\n1> ErrorHandler = fun\n      (throw, {{token, Token}, Rest, Opts, Input, Pos, Buffer}, _Stacktrace) ->\n          Replacement = foo,\n          euneus_decoder:resume(Token, Replacement, Rest, Opts, Input, Pos, Buffer);\n      (Class, Reason, Stacktrace) ->\n          euneus_decoder:handle_error(Class, Reason, Stacktrace)\n   end.\n\n2> Opts = #{error_handler => ErrorHandler}.\n\n3> euneus:decode( >, Opts).\n{ok,[foo,foo,#{ > => foo}]}\n```\n\n> [!NOTE]\n>\n> By using `euneus_decoder:resume/6` the replacement will be the `null_term` option.\n\n#","ref":"readme.html#resuming"},{"type":"extras","title":"Why Euneus over Thoas? - Overview","doc":"`Thoas` is incredible, works performant and perfectly fine, but `Euneus` is more flexible, permitting more customizations, and is more performant than Thoas. See the [benchmarks](#benchmarks).\n\nThe motivation for Euneus is [this PR](https://github.com/lpil/thoas/pull/28).","ref":"readme.html#why-euneus-over-thoas"},{"type":"extras","title":"Benchmarks - Overview","doc":"All the latest runs details can be found under the [runs](./euneus_bench/runs/) directory in the [benchmark project](./euneus_bench/).\n\n#","ref":"readme.html#benchmarks"},{"type":"extras","title":"Encode - Overview","doc":"##","ref":"readme.html#encode"},{"type":"extras","title":"Smart encoding - Overview","doc":"This benchmark uses the JSON smart module via the `euneus:encode/1` function. Smart modules only receive the input as the argument, so no option is available to set. Smart modules are the fastest euneus modules.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     11.14 K \n     &nbsp; \n   \n\n   \n     Jason \n     4.60 K \n     2.42x \n   \n\n   \n     euneus \n     4.49 K \n     2.48x \n   \n\n   \n     thoas \n     3.78 K \n     2.94x \n   \n\n   \n     jsone \n     2.54 K \n     4.39x \n   \n\n   \n     jsx \n     1.00 K \n     11.18x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1162.06 \n     &nbsp; \n   \n\n   \n     Jason \n     429.19 \n     2.71x \n   \n\n   \n     euneus \n     427.23 \n     2.72x \n   \n\n   \n     thoas \n     403.55 \n     2.88x \n   \n\n   \n     jsone \n     213.42 \n     5.44x \n   \n\n   \n     jsx \n     78.73 \n     14.76x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     3.55 K \n     &nbsp; \n   \n\n   \n     Jason \n     1.51 K \n     2.35x \n   \n\n   \n     euneus \n     1.45 K \n     2.44x \n   \n\n   \n     thoas \n     1.30 K \n     2.72x \n   \n\n   \n     jsone \n     0.67 K \n     5.34x \n   \n\n   \n     jsx \n     0.197 K \n     18.01x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     52.04 \n     &nbsp; \n   \n\n   \n     Jason \n     17.91 \n     2.91x \n   \n\n   \n     thoas \n     16.56 \n     3.14x \n   \n\n   \n     euneus \n     14.72 \n     3.53x \n   \n\n   \n     jsone \n     8.58 \n     6.06x \n   \n\n   \n     jsx \n     3.07 \n     16.95x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     36.73 \n     &nbsp; \n   \n\n   \n     Jason \n     27.44 \n     1.34x \n   \n\n   \n     euneus \n     23.24 \n     1.58x \n   \n\n   \n     thoas \n     17.01 \n     2.16x \n   \n\n   \n     jsone \n     16.65 \n     2.21x \n   \n\n   \n     jsx \n     8.75 \n     4.2x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1191.94 \n     &nbsp; \n   \n\n   \n     euneus \n     417.78 \n     2.85x \n   \n\n   \n     Jason \n     411.69 \n     2.9x \n   \n\n   \n     thoas \n     405.74 \n     2.94x \n   \n\n   \n     jsone \n     273.00 \n     4.37x \n   \n\n   \n     jsx \n     97.47 \n     12.23x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1669.42 \n     &nbsp; \n   \n\n   \n     euneus \n     644.19 \n     2.59x \n   \n\n   \n     Jason \n     628.42 \n     2.66x \n   \n\n   \n     thoas \n     613.91 \n     2.72x \n   \n\n   \n     jsone \n     322.22 \n     5.18x \n   \n\n   \n     jsx \n     108.10 \n     15.44x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     14.32 K \n     &nbsp; \n   \n\n   \n     Jason \n     10.11 K \n     1.42x \n   \n\n   \n     euneus \n     9.40 K \n     1.52x \n   \n\n   \n     thoas \n     9.07 K \n     1.58x \n   \n\n   \n     jsx \n     4.76 K \n     3.01x \n   \n\n   \n     jsone \n     1.83 K \n     7.83x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/encode.md).\n\n##","ref":"readme.html#smart-encoding"},{"type":"extras","title":"Encoding with empty map as option - Overview","doc":"This benchmark passes the input and options parsed as the `euneus:encode_parsed/2` function arguments. There is no option set, just an empty map, so all the default options are used. This function it's a bit slower than the smart one, but all options are analyzed in the run.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     11.13 K \n     &nbsp; \n   \n\n   \n     Jason \n     4.62 K \n     2.41x \n   \n\n   \n     euneus \n     3.92 K \n     2.84x \n   \n\n   \n     thoas \n     3.74 K \n     2.98x \n   \n\n   \n     jsone \n     2.55 K \n     4.37x \n   \n\n   \n     jsx \n     1.01 K \n     11.03x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1163.05 \n     &nbsp; \n   \n\n   \n     Jason \n     416.91 \n     2.79x \n   \n\n   \n     thoas \n     396.88 \n     2.93x \n   \n\n   \n     euneus \n     335.54 \n     3.47x \n   \n\n   \n     jsone \n     212.68 \n     5.47x \n   \n\n   \n     jsx \n     79.30 \n     14.67x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     3.50 K \n     &nbsp; \n   \n\n   \n     Jason \n     1.50 K \n     2.34x \n   \n\n   \n     thoas \n     1.28 K \n     2.74x \n   \n\n   \n     euneus \n     1.25 K \n     2.81x \n   \n\n   \n     jsone \n     0.66 K \n     5.31x \n   \n\n   \n     jsx \n     0.199 K \n     17.63x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     51.97 \n     &nbsp; \n   \n\n   \n     Jason \n     17.96 \n     2.89x \n   \n\n   \n     euneus \n     17.40 \n     2.99x \n   \n\n   \n     thoas \n     16.46 \n     3.16x \n   \n\n   \n     jsone \n     8.54 \n     6.09x \n   \n\n   \n     jsx \n     3.08 \n     16.9x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     36.68 \n     &nbsp; \n   \n\n   \n     Jason \n     27.35 \n     1.34x \n   \n\n   \n     euneus \n     24.04 \n     1.53x \n   \n\n   \n     thoas \n     16.94 \n     2.17x \n   \n\n   \n     jsone \n     16.68 \n     2.2x \n   \n\n   \n     jsx \n     8.76 \n     4.19x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1177.53 \n     &nbsp; \n   \n\n   \n     euneus \n     409.80 \n     2.87x \n   \n\n   \n     Jason \n     406.64 \n     2.9x \n   \n\n   \n     thoas \n     399.93 \n     2.94x \n   \n\n   \n     jsone \n     270.72 \n     4.35x \n   \n\n   \n     jsx \n     97.89 \n     12.03x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1659.13 \n     &nbsp; \n   \n\n   \n     Jason \n     620.01 \n     2.68x \n   \n\n   \n     thoas \n     609.24 \n     2.72x \n   \n\n   \n     euneus \n     487.64 \n     3.4x \n   \n\n   \n     jsone \n     321.06 \n     5.17x \n   \n\n   \n     jsx \n     108.35 \n     15.31x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     14.36 K \n     &nbsp; \n   \n\n   \n     Jason \n     10.07 K \n     1.43x \n   \n\n   \n     euneus \n     9.27 K \n     1.55x \n   \n\n   \n     thoas \n     9.07 K \n     1.58x \n   \n\n   \n     jsx \n     4.78 K \n     3.0x \n   \n\n   \n     jsone \n     1.83 K \n     7.86x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/encode_parsed.md).\n\n##","ref":"readme.html#encoding-with-empty-map-as-option"},{"type":"extras","title":"Encoding with all built-in plugins - Overview","doc":"This benchmark passes all the encode built-in plugins to the plugins option:\n\n```erlang\neuneus:parse_encode_opts(#{\n  plugins => [\n    datetime,\n    inet,\n    pid,\n    port,\n    proplist,\n    reference,\n    timestamp\n  ]\n}).\n```\n\nIt's the slowest euneus encode run, but at the same time it is very efficient.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     11.28 K \n     &nbsp; \n   \n\n   \n     Jason \n     4.59 K \n     2.46x \n   \n\n   \n     euneus \n     3.79 K \n     2.97x \n   \n\n   \n     thoas \n     3.79 K \n     2.98x \n   \n\n   \n     jsone \n     2.54 K \n     4.44x \n   \n\n   \n     jsx \n     1.01 K \n     11.2x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1172.88 \n     &nbsp; \n   \n\n   \n     Jason \n     424.49 \n     2.76x \n   \n\n   \n     thoas \n     402.26 \n     2.92x \n   \n\n   \n     euneus \n     332.49 \n     3.53x \n   \n\n   \n     jsone \n     213.21 \n     5.5x \n   \n\n   \n     jsx \n     79.30 \n     14.79x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     3.26 K \n     &nbsp; \n   \n\n   \n     Jason \n     1.52 K \n     2.14x \n   \n\n   \n     thoas \n     1.30 K \n     2.51x \n   \n\n   \n     euneus \n     1.22 K \n     2.67x \n   \n\n   \n     jsone \n     0.66 K \n     4.93x \n   \n\n   \n     jsx \n     0.196 K \n     16.62x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     52.16 \n     &nbsp; \n   \n\n   \n     Jason \n     18.21 \n     2.86x \n   \n\n   \n     thoas \n     16.95 \n     3.08x \n   \n\n   \n     euneus \n     16.66 \n     3.13x \n   \n\n   \n     jsone \n     8.55 \n     6.1x \n   \n\n   \n     jsx \n     3.10 \n     16.83x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     36.70 \n     &nbsp; \n   \n\n   \n     Jason \n     27.43 \n     1.34x \n   \n\n   \n     euneus \n     24.12 \n     1.52x \n   \n\n   \n     thoas \n     16.98 \n     2.16x \n   \n\n   \n     jsone \n     16.66 \n     2.2x \n   \n\n   \n     jsx \n     8.78 \n     4.18x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1188.50 \n     &nbsp; \n   \n\n   \n     Jason \n     412.20 \n     2.88x \n   \n\n   \n     thoas \n     405.50 \n     2.93x \n   \n\n   \n     euneus \n     397.61 \n     2.99x \n   \n\n   \n     jsone \n     272.44 \n     4.36x \n   \n\n   \n     jsx \n     94.44 \n     12.59x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1648.51 \n     &nbsp; \n   \n\n   \n     Jason \n     628.07 \n     2.62x \n   \n\n   \n     thoas \n     613.82 \n     2.69x \n   \n\n   \n     euneus \n     470.18 \n     3.51x \n   \n\n   \n     jsone \n     321.84 \n     5.12x \n   \n\n   \n     jsx \n     108.45 \n     15.2x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     14.38 K \n     &nbsp; \n   \n\n   \n     Jason \n     10.09 K \n     1.42x \n   \n\n   \n     euneus \n     9.41 K \n     1.53x \n   \n\n   \n     thoas \n     9.13 K \n     1.57x \n   \n\n   \n     jsx \n     4.76 K \n     3.02x \n   \n\n   \n     jsone \n     1.79 K \n     8.02x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/encode_parsed_plugins.md).\n\n#","ref":"readme.html#encoding-with-all-built-in-plugins"},{"type":"extras","title":"Decode - Overview","doc":"##","ref":"readme.html#decode"},{"type":"extras","title":"Smart decoding - Overview","doc":"This benchmark uses the decode smart module via the `euneus:decode/1` function. Smart modules only receive the input as the argument, so no option is available to set. Smart modules are the fastest euneus modules.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     5.94 K \n     &nbsp; \n   \n\n   \n     euneus \n     5.77 K \n     1.03x \n   \n\n   \n     Jason \n     5.53 K \n     1.08x \n   \n\n   \n     thoas \n     4.87 K \n     1.22x \n   \n\n   \n     jsone \n     4.26 K \n     1.39x \n   \n\n   \n     jsx \n     1.83 K \n     3.25x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     925.19 \n     &nbsp; \n   \n\n   \n     thoas \n     498.15 \n     1.86x \n   \n\n   \n     euneus \n     494.10 \n     1.87x \n   \n\n   \n     Jason \n     451.81 \n     2.05x \n   \n\n   \n     jsone \n     278.02 \n     3.33x \n   \n\n   \n     jsx \n     162.97 \n     5.68x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     2.69 K \n     &nbsp; \n   \n\n   \n     euneus \n     2.09 K \n     1.29x \n   \n\n   \n     Jason \n     2.01 K \n     1.34x \n   \n\n   \n     thoas \n     1.81 K \n     1.49x \n   \n\n   \n     jsone \n     1.42 K \n     1.9x \n   \n\n   \n     jsx \n     0.51 K \n     5.24x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     27.04 \n     &nbsp; \n   \n\n   \n     Jason \n     17.02 \n     1.59x \n   \n\n   \n     euneus \n     16.79 \n     1.61x \n   \n\n   \n     thoas \n     15.69 \n     1.72x \n   \n\n   \n     jsone \n     9.35 \n     2.89x \n   \n\n   \n     jsx \n     4.40 \n     6.14x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     49.92 \n     &nbsp; \n   \n\n   \n     euneus \n     26.62 \n     1.88x \n   \n\n   \n     Jason \n     25.25 \n     1.98x \n   \n\n   \n     jsone \n     23.25 \n     2.15x \n   \n\n   \n     thoas \n     17.79 \n     2.81x \n   \n\n   \n     jsx \n     9.92 \n     5.03x \n   \n\n \n\n \n    JSON Generator (Pretty)  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1143.30 \n     &nbsp; \n   \n\n   \n     euneus \n     707.45 \n     1.62x \n   \n\n   \n     Jason \n     696.88 \n     1.64x \n   \n\n   \n     thoas \n     624.07 \n     1.83x \n   \n\n   \n     jsone \n     435.82 \n     2.62x \n   \n\n   \n     jsx \n     185.81 \n     6.15x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     698.94 \n     &nbsp; \n   \n\n   \n     euneus \n     616.18 \n     1.13x \n   \n\n   \n     Jason \n     591.72 \n     1.18x \n   \n\n   \n     thoas \n     539.94 \n     1.29x \n   \n\n   \n     jsone \n     400.04 \n     1.75x \n   \n\n   \n     jsx \n     176.01 \n     3.97x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1.36 K \n     &nbsp; \n   \n\n   \n     euneus \n     1.17 K \n     1.16x \n   \n\n   \n     thoas \n     1.15 K \n     1.18x \n   \n\n   \n     Jason \n     1.04 K \n     1.3x \n   \n\n   \n     jsone \n     0.59 K \n     2.31x \n   \n\n   \n     jsx \n     0.26 K \n     5.31x \n   \n\n \n\n \n    UTF-8 escaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     10.41 K \n     &nbsp; \n   \n\n   \n     thoas \n     1.70 K \n     6.14x \n   \n\n   \n     Jason \n     1.69 K \n     6.18x \n   \n\n   \n     euneus \n     1.47 K \n     7.09x \n   \n\n   \n     jsone \n     1.29 K \n     8.09x \n   \n\n   \n     jsx \n     1.16 K \n     8.97x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     18.12 K \n     &nbsp; \n   \n\n   \n     euneus \n     10.44 K \n     1.74x \n   \n\n   \n     Jason \n     10.19 K \n     1.78x \n   \n\n   \n     thoas \n     9.60 K \n     1.89x \n   \n\n   \n     jsone \n     9.44 K \n     1.92x \n   \n\n   \n     jsx \n     6.57 K \n     2.76x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/decode.md).\n\n##","ref":"readme.html#smart-decoding"},{"type":"extras","title":"Decoding with empty map as option - Overview","doc":"This benchmark passes the input and options parsed as the `euneus:decode_parsed/2` function arguments. There is no option set, just an empty map, so all the default options are used. This function it's a bit slower than the smart one, but all options are analyzed in the run.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     5.98 K \n     &nbsp; \n   \n\n   \n     Jason \n     5.55 K \n     1.08x \n   \n\n   \n     thoas \n     4.87 K \n     1.23x \n   \n\n   \n     jsone \n     4.28 K \n     1.4x \n   \n\n   \n     euneus \n     3.59 K \n     1.67x \n   \n\n   \n     jsx \n     1.83 K \n     3.26x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     990.34 \n     &nbsp; \n   \n\n   \n     thoas \n     497.98 \n     1.99x \n   \n\n   \n     Jason \n     456.78 \n     2.17x \n   \n\n   \n     euneus \n     278.42 \n     3.56x \n   \n\n   \n     jsone \n     277.71 \n     3.57x \n   \n\n   \n     jsx \n     167.26 \n     5.92x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     2.70 K \n     &nbsp; \n   \n\n   \n     Jason \n     2.01 K \n     1.35x \n   \n\n   \n     thoas \n     1.82 K \n     1.49x \n   \n\n   \n     jsone \n     1.42 K \n     1.91x \n   \n\n   \n     euneus \n     1.17 K \n     2.3x \n   \n\n   \n     jsx \n     0.52 K \n     5.2x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     27.25 \n     &nbsp; \n   \n\n   \n     Jason \n     17.27 \n     1.58x \n   \n\n   \n     thoas \n     15.78 \n     1.73x \n   \n\n   \n     jsone \n     9.55 \n     2.85x \n   \n\n   \n     euneus \n     7.82 \n     3.49x \n   \n\n   \n     jsx \n     4.45 \n     6.13x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     49.74 \n     &nbsp; \n   \n\n   \n     Jason \n     25.26 \n     1.97x \n   \n\n   \n     euneus \n     25.23 \n     1.97x \n   \n\n   \n     jsone \n     23.29 \n     2.14x \n   \n\n   \n     thoas \n     17.98 \n     2.77x \n   \n\n   \n     jsx \n     9.97 \n     4.99x \n   \n\n \n\n \n    JSON Generator (Pretty)  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1162.25 \n     &nbsp; \n   \n\n   \n     Jason \n     694.53 \n     1.67x \n   \n\n   \n     thoas \n     625.05 \n     1.86x \n   \n\n   \n     jsone \n     436.44 \n     2.66x \n   \n\n   \n     euneus \n     347.69 \n     3.34x \n   \n\n   \n     jsx \n     191.09 \n     6.08x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     696.27 \n     &nbsp; \n   \n\n   \n     Jason \n     586.85 \n     1.19x \n   \n\n   \n     thoas \n     541.03 \n     1.29x \n   \n\n   \n     jsone \n     400.67 \n     1.74x \n   \n\n   \n     euneus \n     317.16 \n     2.2x \n   \n\n   \n     jsx \n     181.31 \n     3.84x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1.35 K \n     &nbsp; \n   \n\n   \n     thoas \n     1.15 K \n     1.18x \n   \n\n   \n     Jason \n     1.04 K \n     1.3x \n   \n\n   \n     jsone \n     0.59 K \n     2.29x \n   \n\n   \n     euneus \n     0.40 K \n     3.34x \n   \n\n   \n     jsx \n     0.26 K \n     5.27x \n   \n\n \n\n \n    UTF-8 escaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     10.38 K \n     &nbsp; \n   \n\n   \n     Jason \n     1.70 K \n     6.09x \n   \n\n   \n     thoas \n     1.70 K \n     6.11x \n   \n\n   \n     euneus \n     1.45 K \n     7.18x \n   \n\n   \n     jsone \n     1.30 K \n     7.97x \n   \n\n   \n     jsx \n     1.18 K \n     8.83x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     18.07 K \n     &nbsp; \n   \n\n   \n     euneus \n     10.37 K \n     1.74x \n   \n\n   \n     Jason \n     10.20 K \n     1.77x \n   \n\n   \n     thoas \n     9.59 K \n     1.89x \n   \n\n   \n     jsone \n     9.51 K \n     1.9x \n   \n\n   \n     jsx \n     6.58 K \n     2.75x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/decode_parsed.md).\n\n##","ref":"readme.html#decoding-with-empty-map-as-option"},{"type":"extras","title":"Decoding with all built-in plugins - Overview","doc":"This benchmark passes all the decode built-in plugins to the plugins option:\n\n```erlang\neuneus:parse_decode_opts(#{\n  plugins => [\n    datetime,\n    timestamp,\n    pid,\n    port,\n    reference,\n    inet\n  ]\n}).\n```\n\n> [!NOTE]\n>\n> The `proplist` plugin is only available for encoding.\n\nIt's the slowest euneus decode run, but at the same time it is very efficient.\n\n \n\n \n\n \n    Blockchain  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     5.98 K \n     &nbsp; \n   \n\n   \n     Jason \n     5.55 K \n     1.08x \n   \n\n   \n     thoas \n     4.87 K \n     1.23x \n   \n\n   \n     jsone \n     4.28 K \n     1.4x \n   \n\n   \n     euneus \n     3.59 K \n     1.67x \n   \n\n   \n     jsx \n     1.83 K \n     3.26x \n   \n\n \n\n \n    Giphy  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     990.34 \n     &nbsp; \n   \n\n   \n     thoas \n     497.98 \n     1.99x \n   \n\n   \n     Jason \n     456.78 \n     2.17x \n   \n\n   \n     euneus \n     278.42 \n     3.56x \n   \n\n   \n     jsone \n     277.71 \n     3.57x \n   \n\n   \n     jsx \n     167.26 \n     5.92x \n   \n\n \n\n \n    GitHub  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     2.70 K \n     &nbsp; \n   \n\n   \n     Jason \n     2.01 K \n     1.35x \n   \n\n   \n     thoas \n     1.82 K \n     1.49x \n   \n\n   \n     jsone \n     1.42 K \n     1.91x \n   \n\n   \n     euneus \n     1.17 K \n     2.3x \n   \n\n   \n     jsx \n     0.52 K \n     5.2x \n   \n\n \n\n \n    GovTrack  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     27.25 \n     &nbsp; \n   \n\n   \n     Jason \n     17.27 \n     1.58x \n   \n\n   \n     thoas \n     15.78 \n     1.73x \n   \n\n   \n     jsone \n     9.55 \n     2.85x \n   \n\n   \n     euneus \n     7.82 \n     3.49x \n   \n\n   \n     jsx \n     4.45 \n     6.13x \n   \n\n \n\n \n    Issue 90  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     49.74 \n     &nbsp; \n   \n\n   \n     Jason \n     25.26 \n     1.97x \n   \n\n   \n     euneus \n     25.23 \n     1.97x \n   \n\n   \n     jsone \n     23.29 \n     2.14x \n   \n\n   \n     thoas \n     17.98 \n     2.77x \n   \n\n   \n     jsx \n     9.97 \n     4.99x \n   \n\n \n\n \n    JSON Generator (Pretty ) \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1162.25 \n     &nbsp; \n   \n\n   \n     Jason \n     694.53 \n     1.67x \n   \n\n   \n     thoas \n     625.05 \n     1.86x \n   \n\n   \n     jsone \n     436.44 \n     2.66x \n   \n\n   \n     euneus \n     347.69 \n     3.34x \n   \n\n   \n     jsx \n     191.09 \n     6.08x \n   \n\n \n\n \n    JSON Generator  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     696.27 \n     &nbsp; \n   \n\n   \n     Jason \n     586.85 \n     1.19x \n   \n\n   \n     thoas \n     541.03 \n     1.29x \n   \n\n   \n     jsone \n     400.67 \n     1.74x \n   \n\n   \n     euneus \n     317.16 \n     2.2x \n   \n\n   \n     jsx \n     181.31 \n     3.84x \n   \n\n \n\n \n    Pokedex  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     1.35 K \n     &nbsp; \n   \n\n   \n     thoas \n     1.15 K \n     1.18x \n   \n\n   \n     Jason \n     1.04 K \n     1.3x \n   \n\n   \n     jsone \n     0.59 K \n     2.29x \n   \n\n   \n     euneus \n     0.40 K \n     3.34x \n   \n\n   \n     jsx \n     0.26 K \n     5.27x \n   \n\n \n\n \n    UTF-8 escaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     10.38 K \n     &nbsp; \n   \n\n   \n     Jason \n     1.70 K \n     6.09x \n   \n\n   \n     thoas \n     1.70 K \n     6.11x \n   \n\n   \n     euneus \n     1.45 K \n     7.18x \n   \n\n   \n     jsone \n     1.30 K \n     7.97x \n   \n\n   \n     jsx \n     1.18 K \n     8.83x \n   \n\n \n\n \n    UTF-8 unescaped  \n   \n     Name \n     IPS \n     Slower \n   \n     jiffy \n     18.07 K \n     &nbsp; \n   \n\n   \n     euneus \n     10.37 K \n     1.74x \n   \n\n   \n     Jason \n     10.20 K \n     1.77x \n   \n\n   \n     thoas \n     9.59 K \n     1.89x \n   \n\n   \n     jsone \n     9.51 K \n     1.9x \n   \n\n   \n     jsx \n     6.58 K \n     2.75x \n   \n\n \n\n \n\n \n\nAll benchmark details are available [here](./euneus_bench/runs/decode_parsed_plugins.md).","ref":"readme.html#decoding-with-all-built-in-plugins"},{"type":"extras","title":"Tests - Overview","doc":"There are Eunit tests in [euneus_encoder](/src/euneus_encoder.erl) and [euneus_decoder](/src/euneus_decoder.erl) and tests suites in a specific project under the [euneus_test](/euneus_test/) directory. Euneus has more than 330 tests.\n\nAlso, the parser is tested using [JSONTestSuite](https://github.com/nst/JSONTestSuite) and all tests passes:\n\n![JSON Test Suite](/assets/images/json-test-suite-result.png)\n\nSee the [Euneus parser](https://github.com/nst/JSONTestSuite/tree/master/parsers/test_erlang_euneus) in JSONTestSuite.\n\n> [!NOTE]\n>\n> All of the JSONTestSuite tests are embedded in Euneus tests.","ref":"readme.html#tests"},{"type":"extras","title":"Smart modules - Overview","doc":"Euneus has modules that permit customizations and others that use the default options. The modules without customizations are called smart. The smart versions are faster because they do not do any option checks.\n\nIf you are good to go with the default options, please use the smart versions:\n- Encode:\n    - `euneus:encode/1` or `euneus_encoder_smart_json:encode/1`;\n    - `euneus:encode_js/1` or `euneus_encoder_smart_javascript:encode/1`;\n    - `euneus:encode_html/1` or `euneus_encoder_smart_html:encode/1`;\n    - `euneus:encode_unicode/1` or `euneus_encoder_smart_unicode:encode/1`;\n- Decode:\n    - `euneus:decode/1` or `euneus_decoder_smart:decode/1`.","ref":"readme.html#smart-modules"},{"type":"extras","title":"Credits - Overview","doc":"Euneus is a rewrite of Thoas, so all credits go to [Michał Muskała](https://github.com/michalmuskala), [Louis Pilfold](https://github.com/lpil), also both [Jason][jason] and [Thoas][thoas] contributors. Thanks for the hard work!","ref":"readme.html#credits"},{"type":"extras","title":"Why the name Euneus? - Overview","doc":"Euneus is the twin brother of [Thoas](https://en.wikipedia.org/wiki/Thoas_(son_of_Jason)).","ref":"readme.html#why-the-name-euneus"},{"type":"extras","title":"Sponsors - Overview","doc":"If you like this tool, please consider [sponsoring me](https://github.com/sponsors/williamthome).\nI'm thankful for your never-ending support :heart:\n\nI also accept coffees :coffee:\n\n[![\"Buy Me A Coffee\"](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/williamthome)","ref":"readme.html#sponsors"},{"type":"extras","title":"Contributing - Overview","doc":"#","ref":"readme.html#contributing"},{"type":"extras","title":"Issues - Overview","doc":"Feel free to [submit an issue on Github](https://github.com/williamthome/euneus/issues/new).\n\n#","ref":"readme.html#issues"},{"type":"extras","title":"Installation - Overview","doc":"```console\n# Clone this repo\ngit clone git@github.com:williamthome/euneus.git\n\n# Navigate to the project root\ncd euneus\n\n# Compile (ensure you have rebar3 installed)\nrebar3 compile\n```\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Commands - Overview","doc":"```\n# Benchmark euneus:encode/1\n$ make bench.encode\n```\n\n```\n# Benchmark euneus:decode/1\n$ make bench.decode\n```\n\n```\n# Run all tests\n$ make test\n```\n\n```\n# Run all tests and dialyzer\n$ make check\n```\n\n> [!NOTE]\n>\n> Open the [Makefile](Makefile) to see all commands.","ref":"readme.html#commands"},{"type":"extras","title":"License - Overview","doc":"Euneus is released under the [Apache License 2.0](LICENSE.md).\n\nEuneus is based on [Thoas][thoas], which is also Apache 2.0 licensed.\n\nSome elements have their origins in the [Poison library][poison] and were initially licensed under [CC0-1.0](https://creativecommons.org/publicdomain/zero/1.0/).\n\n[jason]: https://github.com/michalmuskala/jason\n[thoas]: https://github.com/lpil/thoas\n[poison]: https://github.com/devinus/poison","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2023, William Fank Thomé  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\nhttp://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"content_type":"text/plain"}